# Shlagernetes deployer - Specifications

# Context

Shlagernetes is an orchestration tool allowing services to be stored on second-hand servers. It handles the configuration of the servers, the installation and maintenance of services as well as their deletion. Services can be static or dynamic websites, VPNs, etc. They can be in a container if required but not necessarily.
Shlagernetes works with an nginx reverse proxy, wireguard VPN, letsencrypt ssl certification and Git versioning.

Shl8s works with the principle of Infrastructure As Code. 
On every server, there will be an instance of the Shl8s deployer. This C++ deployer behaves according to the instructions passed by the system administrator.
It then procedes to execute the right functions for the service.
The deployer will call bash scripts specific to the service, as well as functions from libraries specific to setting the nginx configuration, the vpn, ssl certification, etc.

# Description
main.cpp 
- reads the instructions
- determines if the service is on the server
if it is: 
- creates directories (secret, data, http) if necessary 
- calls the bash scripts specific to the service if they exist (deploy_as)
- calls the right deployment functions according to the instructions, from the deployment libraries 
- calls the DNS service ? 
- user creation ? 
- environment variables creation ? 

Deployment libraries : 
- nginx configuration
    preparation
    deployment
    reload
- wireguard
- encryption 
- docker 


